//****************************************************************************
// @Module        Project Settings
// @Filename      MAIN.C
// @Project       R.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC164CM-8F40
//
// @Compiler      Keil
//
// @Codegenerator 1.0
//
// @Description   This file contains the project initialization function.
//
//----------------------------------------------------------------------------
// @Date          27/1/2000 9:09:05 
//
//****************************************************************************

// USER CODE BEGIN (MAIN_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (MAIN_General,2)
	 #include <stdio.H>
	  #include <stdlib.H>
	  #include <string.h>
// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (MAIN_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (MAIN_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (MAIN_General,5)


//STATES ENUMERATION
 typedef enum {    Led_off,        Uart_on,             Led_on,         Uart_off           }      state; 
 
																						  
																						  
//TRANSITION STATES ENUMERATIOM																						           
typedef enum    {Led_on__Uart_off,  Uart_off_Led_off,  Led_off_Uart_on,  Uart_on_Led_on }event; 

                 
 

 typedef void  (*action)();



 // STATES

 void  led_on (void);


 void led_off (void);

 void uart_on(void);

 void uart_off(void);



typedef struct s{

state next;
action todo;
}action_and_next_state;                                      


 state courent=Led_off;


void statecalculation( int x);						

action_and_next_state stateevaluation;

action_and_next_state ar[4][2]=  { {  Uart_on_Led_on, uart_on }, {  Led_on__Uart_off, led_off} ,{ Uart_off_Led_off, uart_off}, \
 { Led_off_Uart_on,led_on} };                                              
 

 
 

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,7)


 void delay (unsigned int d);  

   


                                   
// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************

// USER CODE BEGIN (MAIN_General,8)

// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (MAIN_General,9)
 

   
	 

	 
	 
	 
	                         
// USER CODE END


//****************************************************************************
// @Function      void MAIN_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This function initializes the microcontroller.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

// USER CODE BEGIN (Init,1)

// USER CODE END

void MAIN_vInit(void)
{
  // USER CODE BEGIN (Init,2)

  // USER CODE END

  ///  -----------------------------------------------------------------------
  ///  Configuration of the System Clock:
  ///  -----------------------------------------------------------------------
  ///  - VCO clock used, input clock is connected
  ///  - input frequency is 8 MHz
  ///  - VCO output frequency 150 .. 200 MHz
  ///  - system clock is 40 MHz

  MAIN_vUnlockProtecReg();       // unlock write security
  PLLCON         =  0x7844;      // load PLL control register


  //// -----------------------------------------------------------------------
  //// Begin of Important Settings for the Start-Up File
  //// -----------------------------------------------------------------------
  ///  All following settings must be set in the start-up file. You can use 
  ///  DAvE's project file (*.dpt) to include this register values into your 
  ///  compiler EDE.

    ///  ---------------------------------------------------------------------
    ///  Initialization of the CPUCON1 Register:
    ///  ---------------------------------------------------------------------
    ///  - space between two vectors is 2 words
    ///  - DISWDT executable until End of Init
    ///  - segmentation is enabled
    ///  - switch context is interruptible
    ///  - branch prediction is enabled
    ///  - zero cycle jump function is enabled

    //// this register must be set in the start-up file
    //// CPUCON1  =  0x0007

    ///  ---------------------------------------------------------------------
    ///  Initialization of the VECSEG Register:
    ///  ---------------------------------------------------------------------
    ///  - start from internal program memory

    //// this register must be set in the start-up file
    //// VECSEG  =  0x00C0

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON0 Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// SYSCON0  =  0x0000

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON1 Register:
    ///  ---------------------------------------------------------------------
    ///  clock prescaler for system is fpll / 1
    ///  clock prescaler for PD+ bus is fcpu / 1

    //// this register must be set in the start-up file
    //// SYSCON1  =  0x0000

    ///  ---------------------------------------------------------------------
    ///  Initialization of the SYSCON3 Register:
    ///  ---------------------------------------------------------------------

    //// this register must be set in the start-up file
    //// SYSCON3  =  0x0000

  //// -----------------------------------------------------------------------
  //// End of Important Settings for the Start-Up File
  //// -----------------------------------------------------------------------


  //   -----------------------------------------------------------------------
  //   Initialization of the Peripherals:
  //   -----------------------------------------------------------------------

  //   initializes the Parallel Ports
  IO_vInit();

  //   initializes the Asynchronous/Synchronous Serial Interface (ASC0)
  ASC0_vInit();

  // USER CODE BEGIN (Init,3)

  // USER CODE END

  //   globally enable interrupts
  PSW_IEN        =  1;          

} //  End of function MAIN_vInit


//****************************************************************************
// @Function      void MAIN_vUnlockProtecReg(void) 
//
//----------------------------------------------------------------------------
// @Description   This function makes it possible to write one protected 
//                register. After calling of this function and write on the 
//                protected register is the security level set to low 
//                protected mode.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

// USER CODE BEGIN (UnlockProtecReg,1)

// USER CODE END

void MAIN_vUnlockProtecReg(void)
{
  uword uwPASSWORD;

  if((SCUSLS & 0x1800) == 0x0800)      // if low protected mode
  {

    uwPASSWORD = SCUSLS & 0x00FF;
    uwPASSWORD = (~uwPASSWORD) & 0x00FF;
    SCUSLC = 0x8E00 | uwPASSWORD;      // command 4

  }  // end if low protected mode

  if((SCUSLS & 0x1800) == 0x1800)      // if write protected mode
  {
    SCUSLC = 0xAAAA;                   // command 0
    SCUSLC = 0x5554;                   // command 1

    uwPASSWORD = SCUSLS & 0x00FF;
    uwPASSWORD = (~uwPASSWORD) & 0x00FF;

    SCUSLC = 0x9600 | uwPASSWORD;      // command 2
    SCUSLC = 0x0800;                   // command 3; new PASSWOR is 0x00

    uwPASSWORD = SCUSLS & 0x00FF;
    uwPASSWORD = (~uwPASSWORD) & 0x00FF;
    SCUSLC = 0x8E00 | uwPASSWORD;      // command 4

  }  // end if write protected mode

} //  End of function MAIN_vUnlockProtecReg


//****************************************************************************
// @Function      void main(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the main function.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

// USER CODE BEGIN (Main,1)

 



 


// USER CODE END

void main(void)

{
  // USER CODE BEGIN (Main,2)



int zz=Led_off;	//casting enumerration  to integer !!!
 

  // USER CODE END

  MAIN_vInit();

  // USER CODE BEGIN (Main,4)

  


  while (1)
{  
	
   statecalculation ( zz); 
 
	delay(50000);
  			  
   }

         

  }
 


//==================================================	  		  
 
 void delay (unsigned int d)
 {
 unsigned int x ,y;

 for (x=0;x<=d;x++)
 {
 for( y=0;y<=1500;y++)
		;
 }
 }

//===============================================
void  led_on ()
 {

 P1L_P1= 0;
 }	 

//========================================================
void  led_off ()
{

 P1L_P1= 1;
 
 }

	  
  
 //====================================================


 void statecalculation(int x)
 {

 stateevaluation= ar[courent][x];  // action_and_next_state stateevaluation;
 courent= stateevaluation.next;

 (stateevaluation).todo();

 }
  
    
   
//========================================================

void uart_on (void)
 {


printf ( " I'll turn the led on  \n" );

}
	

 //========================================================


  void uart_off (void) {


printf ( " I'll turn the led off  \n" );

}





  // USER CODE END

//  End of function main



// USER CODE BEGIN (MAIN_General,10)

// USER CODE END

